var global_rtn_video = global_rtn_video || null;
var global_document_url = global_document_url || null;
var global_video_id = global_video_id || null;
var golbal_img = golbal_img|| "";

function vid_mate_get_video_id(url) {
	var vid_mate_url = url || document.URL;
	if (vid_mate_url == null || vid_mate_url.length <= 0) {
		return null;
	}
	//http://www.espncricinfo.com/ci/content/video_audio/824429.html
	if(-1 == vid_mate_url.indexOf("espncricinfo.com"))
	{
		return null;
	}
	var tmp_re = new RegExp("/video_audio/([0-9]+)\.html$");
	if (tmp_re.test(vid_mate_url)) {
		var tmp_m = vid_mate_url.match(tmp_re);
		return tmp_m[1];
	}
	return null;
}

function vid_mate_check() {
	if (vid_mate_get_video_id() == null) {
		vid_mate_set_canDownload(false);
		return false;
	} else {
	    vid_mate_set_canDownload(true);
		return true;
	}
}

function vid_mate_get_video_info(url)
{
    vid_mate_setParseMsg(10, 20, 'Start Analytics');

	var vid_mate_video_id = vid_mate_get_video_id(url);
	global_video_id = vid_mate_video_id;
	vid_mate_setParseMsg(20, 60, 'Get Video Info...');

	global_document_url = url;

	try {
		vid_mate_setParseMsg(20, 60, 'Get Video Info......');

		var referer = url;
		var cookie = "";
		if(window.vbrowser.httpGetCookie)
		{
			cookie = window.vbrowser.httpGetCookie(global_document_url);
		}
		else
		{
			cookie = document.cookie;
		}

		var userAgent = "Mozilla/5.0 (Linux; Android 4.3; Build/KRT16M) AppleWebKit/517.36 (KHTML, like Gecko) Version/4.0 Chrome/30.0.0.0 Mobile Safari/537.36";
		//var userAgent = navigator.userAgent;
		var method = "get";
		var data = "";
		vid_mate_app_xhr_adv(url, referer, cookie, userAgent, method, data);
	} catch (e) {
		vid_mate_error_default('espncricinfo 1');
		return null;
	}
}

function vid_mate_video_analytics(vm_content)
{
	if(!vm_content)
	{
		vid_mate_error_default('vm_content is empty');
		return null;
	}

	var video_data_id = cutstr(vm_content, "data-id=\"", "\"");
	if(!video_data_id)
	{
		vid_mate_error_default('get data-id fail.');
		return null;
	}

	//img
	var img = cutstr(vm_content, "<meta property=\"og:image\" content=\"", "\"");
	if(img)
	{
		golbal_img = img;
	}

	var d = new Date();
	var t = d.getTime() + 7 * 86400 * 1000;
	var url = "http://espn.go.com/espn360/cerebro/util/getClipById?id="+video_data_id+"&callback=jQuery17100839"+t+"_"+t+"&xhr=1";

	try {

		var referer = global_document_url;
		var cookie = "";

		var userAgent = "Mozilla/5.0 (Linux; Android 4.3; Build/KRT16M) AppleWebKit/517.36 (KHTML, like Gecko) Version/4.0 Chrome/30.0.0.0 Mobile Safari/537.36";
		//var userAgent = navigator.userAgent;
		var method = "get";
		var data = "";
        window.vbrowser.httpBegin(url);
        if (referer != null && referer.length > 0) {
            window.vbrowser.httpSetHeader("Referer", referer);
        }
        if (cookie != null && cookie.length > 0) {
            window.vbrowser.httpSetHeader("Cookie", cookie);
        }
        if (userAgent != null && userAgent.length > 0) {
            window.vbrowser.httpSetHeader("User-Agent", userAgent);
        }
        if (method == "POST") {
            window.vbrowser.httpPost(data, 'espn_xhr_result()');
        } else {
            window.vbrowser.httpGet('espn_xhr_result()');
        }
	} catch (e) {
		vid_mate_error_default('espncricinfo 2');
		return null;
	}
}

function espn_xhr_result()
{
    var vid_mate_response;

	try {
        vid_mate_response = window.vbrowser.getHttpRes();
    } catch (e) {
		vid_mate_error(vid_mate_error_msg, e.name + ": " + e.message);
	}

    if (vid_mate_response != null && vid_mate_response.length > 0) {
        espn_analytics(vid_mate_response);
    }
}

function espn_analytics(vm_content)
{
	var tmp = cutstr(vm_content, "[{\"", "}])");
	if(!tmp)
	{
		vid_mate_error_default('espncricinfo 3');
		return null;
	}
	tmp = "{\""+tmp+"}";
	var data = eval('('+tmp+')');
	if(!data)
	{
		vid_mate_error_default('espncricinfo 4');
		return null;
	}

	var title = data['headlineShort'];
	if(!title)
	{
		title = "Mp4";
	}
	var img = golbal_img;
	var videoUrl = data['syndicationDetails']['cricinfo']['brightcove']['url'];
	if(!videoUrl)
	{
		vid_mate_error_default('espncricinfo 4');
		return null;
	}

	var rtn_video = new vid_mate_video();
	rtn_video.check_type = "espncricinfo";
	rtn_video.id = global_video_id;
	rtn_video.title = title;

	rtn_video.url = document.URL;
	rtn_video.picture_default = img;
	rtn_video.picture_big = img;

	var tmp_video_file = new vid_mate_video_file();
	tmp_video_file.url = videoUrl;
	tmp_video_file.format = "mp4";
	tmp_video_file.title = "mp4";
	tmp_video_file.f_id = rtn_video.id;
	rtn_video.files.push(tmp_video_file);

	global_rtn_video = rtn_video;

	var videoUrlArray = [];
	videoUrlArray.push(videoUrl);

	var cookie = "";
	try {
		window.vbrowser.httpBeginGetAll();
		for(var i=0; i<videoUrlArray.length; ++i)
		{
			var url = "http://api.apk.vidmate.net/url?url="+encodeURIComponent(videoUrlArray[i]) + "&cookie="+encodeURIComponent(cookie);
			window.vbrowser.httpAddUrl(url);
		}
		window.vbrowser.httpGetAll('vid_mate_app_xhr_more_result()');
	}
	catch (e) {
		vid_mate_error_default('coolmoviez 4\r\n' + e.name + ": " + e.message);
	}
}

function vid_mate_app_xhr_more_result() {
	var rtn_contents = [];
	try {
		var tmp_count = window.vbrowser.httpGetResCount();
		for (var i = 0;i < tmp_count;i ++) {
			var tmp_content = window.vbrowser.httpGetResAtIndex(i);
			rtn_contents.push(tmp_content);
		}
	} catch (e) {
		vid_mate_error_default('espncricinfo 99 ' + e.name + ": " + e.message);
	}

	vid_mate_video_analytics_more(rtn_contents);
}


function vid_mate_video_analytics_more(vm_content_array)
{
	if(1 != vm_content_array.length)
	{
		vid_mate_error_default('espncricinfo 5');
		return null;
	}

	var videoUrl = vm_content_array[0];
	if(videoUrl)
	{
		global_rtn_video.files[0].url = videoUrl;
	}

	vid_mate_setParseMsg(100, 100, 'Completed');
	vid_mate_set_videoInfo(JSON.stringify(global_rtn_video));
}

function vid_mate_get_video_info_on_blank(url)
{
	vid_mate_get_video_info(url);
}

function cutstr(content, prefix, suffix)
{
	var prefix_len = prefix.length;
	var p1 = content.indexOf(prefix);
	if(-1 == p1)
	{
		return "";
	}
	p1 += prefix_len;
	var p2 = content.indexOf(suffix, p1);
	if(-1 == p2)
	{
		return "";
	}
	return content.substring(p1, p2);
}
