var global_rtn_video = global_rtn_video || null;
var global_document_url = global_document_url || null;
var global_video_id = global_video_id || null;
var global_title = "";
function vid_mate_get_video_id(url)
{
	var vid_mate_url = url || document.URL;
	if (vid_mate_url == null || vid_mate_url.length <= 0) {
		return null;
	}
	if(-1 == vid_mate_url.indexOf("yo-desi"))
	{
		return null;
	}
	if(-1 == vid_mate_url.indexOf("player.php"))
	{
		return null;
	}
	var vid_mate_video_id = vid_mate_get_parameter(vid_mate_url, "id");
	if(vid_mate_video_id)
	{
		return vid_mate_video_id;
	}
	return null;
}

function vid_mate_check() {
	if (vid_mate_get_video_id() == null) 
	{
		vid_mate_set_canDownload(false);
		return false;
	} 
	else 
	{
	    vid_mate_set_canDownload(true);
		return true;
	}
}

function vid_mate_get_video_info(url)
{
    vid_mate_setParseMsg(10, 20, 'Start Analytics');
	var vid_mate_video_id = vid_mate_get_video_id(url);
	vid_mate_setParseMsg(20, 60, 'Get Video Info');
	global_video_id = vid_mate_video_id;
	global_document_url = url;
	try {
		vid_mate_setParseMsg(20, 60, 'Get Video Info......');

		var referer = url;
		var cookie = "";
		if(window.vbrowser.httpGetCookie)
		{
			cookie = window.vbrowser.httpGetCookie(global_document_url);
		}
		else
		{
			cookie = document.cookie;
		}
		var userAgent = "Mozilla/5.0 (Linux; Android 4.3; Build/KRT16M) AppleWebKit/517.36 (KHTML, like Gecko) Version/4.0 Chrome/30.0.0.0 Mobile Safari/537.36";
		var method = "get";
		var data = "";
		vid_mate_app_xhr_adv(url, referer, cookie, userAgent, method, data);
	} catch (e) {
		vid_mate_error_default('yodesi 1');
		return null;
	}
}

function vid_mate_video_analytics(vm_content)
{
	if(!vm_content)
	{
		vid_mate_error_default('vm_content is empty');
		return null;
	}
	
	var src_url = cutstr(vm_content, "data-config=\"", "\"");
	if(!src_url)
	{
		src_url = cutstr(vm_content, "<iframe", "</iframe>");
		if(!src_url)
		{
			src_url = cutstr(vm_content, "<IFRAME", "</IFRAME>");
			if(src_url)
			{
				src_url = cutstr(src_url, "SRC=\"", "\"");
			}
		}
		else
		{
			src_url = cutstr(src_url, "src=\"", "\"");
		}
	}

	if(!src_url)
	{
		vid_mate_error_default('src url is empty');
		return null;
	}
	
	if(-1 == src_url.indexOf("http://"))
	{
		if(-1 == src_url.indexOf("//"))
		{
			src_url = "http://" + src_url;
		}
		else
		{
			src_url = "http:" + src_url;
		}
	}
	
	global_title = cutstr(vm_content, "text-align:center\">", "</h2>");
	try_backend_reqeust(src_url);
}

function try_backend_reqeust(src_url)
{
	try {
		window.vbrowser.httpBegin(src_url);
		window.vbrowser.httpGet('backend_xhr_result()');
	} catch (e) {
		vid_mate_error_default('yodesi try_backend_reqeust');
		return null;
	}
}

function backend_xhr_result()
{
    var vid_mate_response;
	try
	{
        vid_mate_response = window.vbrowser.getHttpRes();
    }
	catch (e)
	{
		vid_mate_error_default("yodesi backend_xhr_result1");
		return null;
	}

    if (vid_mate_response != null && vid_mate_response.length > 0)
	{
        vid_mate_video_analytics1(vid_mate_response);
    }
	else
	{
		vid_mate_error_default("yodesi backend_xhr_result2");
		return null;
	}
}

function vid_mate_video_analytics1(vm_content)
{
	if(!vm_content)
	{
		vid_mate_error_default('vm_content is empty');
		return null;
	}

	var videoUrl = "";
	var videoTitle = "";
	var videoImg = "";

	var rtn_video = new vid_mate_video();
	rtn_video.check_type = "yodesi";
	rtn_video.id = global_video_id;
	rtn_video.js_ver  = "1.01";
	rtn_video.js_info = "20160108:first version";
	if(-1 != vm_content.indexOf("dmp.create(document.getElementById('player'),"))
	{
		yodesi_dailymotion_analytics(rtn_video, vm_content);
	}
	else if(-1 != vm_content.indexOf("hostingId") && -1 != vm_content.indexOf("videoId"))
	{
		yodesi_flash_analytics(rtn_video, vm_content);
	}
	else
	{
		yodesi_other_analytics(rtn_video, vm_content);
	}
	
	if(0 == rtn_video.files.length)
	{
		vid_mate_error_default('yodesi a6');
		return null;
	}
	
	vid_mate_setParseMsg(100, 100, 'Completed');
	vid_mate_set_videoInfo(JSON.stringify(rtn_video));	
}

function vid_mate_get_video_info_on_blank(url)
{
	vid_mate_get_video_info(url);
}

document.onscroll = function()
{
	var videos = document.getElementsByClassName('thecontent');
	if(videos.length < 1)
	{
		return null;
	}
	var video = videos[0];
	var spans = video.getElementsByTagName('span');
	var ps = video.getElementsByTagName('p');
	var del_arr_ps = [];
	var del_arr_spans = [];
	for(var i = 0;i < spans.length; i++)
	{
		if(-1 != spans[i].innerHTML.toLocaleUpperCase().indexOf("EMBEDVIDEO 720P HD VIDEOS"))
		{
			del_arr_ps.push(ps[i]);
			del_arr_spans.push(spans[i]);
		}	
		if(-1 != spans[i].innerHTML.toLocaleUpperCase().indexOf("NOWVIDEO 720P HD VIDEOS"))
		{
			del_arr_ps.push(ps[i]);
			del_arr_spans.push(spans[i]);
		}	
		if(-1 != spans[i].innerHTML.toLocaleUpperCase().indexOf("NOWDOWNLOAD 720P HD VIDEOS"))
		{
			del_arr_ps.push(ps[i]);
			del_arr_spans.push(spans[i]);
		}	
		if(-1 != spans[i].innerHTML.toLocaleUpperCase().indexOf("LETWATCH 720P HD VIDEOS"))
		{
			del_arr_ps.push(ps[i]);
			del_arr_spans.push(spans[i]);
		}	
		if(-1 != spans[i].innerHTML.toLocaleUpperCase().indexOf("CLOUDY 720P HD VIDEOS"))
		{
			del_arr_ps.push(ps[i]);
			del_arr_spans.push(spans[i]);
		}	
		if(-1 != spans[i].innerHTML.toLocaleUpperCase().indexOf("MP4UPLOAD 720P HD VIDEOS"))
		{
			del_arr_ps.push(ps[i]);
			del_arr_spans.push(spans[i]);
		}
		if(-1 != spans[i].innerHTML.toLocaleUpperCase().indexOf("720P VIDEOS OVER HERE"))
		{
			del_arr_ps.push(ps[i]);
			del_arr_spans.push(spans[i]);
		}	
		if(-1 != spans[i].innerHTML.toLocaleUpperCase().indexOf("IDOWATCH 720P HD VIDEOS"))
		{
			del_arr_ps.push(ps[i]);
			del_arr_spans.push(spans[i]);
		}			
	}

	var len = del_arr_ps.length;
	for(var i = 0; i < len; i++)
	{
		var tmp_ps = del_arr_ps.pop();
		tmp_ps.remove();
		
		var tmp_spans = del_arr_spans.pop();
		tmp_spans.parentNode.remove();
	}
}

function cutstr(content, prefix, suffix)
{
	var prefix_len = prefix.length;
	var p1 = content.indexOf(prefix);
	if(-1 == p1)
	{
		return "";
	}
	p1 += prefix_len;
	var p2 = content.indexOf(suffix, p1);
	if(-1 == p2)
	{
		return "";
	}
	return content.substring(p1, p2);
}

function yodesi_dailymotion_analytics(rtn_video, vm_content)
{
	var content = vm_content;
	var vid_mate_ytplayer_config = "";
	content = cutstr(content, "dmp.create(document.getElementById('player'), ", ");");
	if(!content)
	{
		vid_mate_error_default('yodesi a2');
		return null;
	}

	var vid_mate_dmplayer_config = eval('(' + content + ')');
	if (!vid_mate_dmplayer_config)
	{
		vid_mate_error_default('yodesi 3');
		return null;
	}

	if(!vid_mate_dmplayer_config['metadata'])
	{
		vid_mate_error_default('yodesi a3');
		return null;
	}

	rtn_video.title = vid_mate_dmplayer_config['metadata']['title'];
	rtn_video.url = vid_mate_dmplayer_config['metadata']['url'];
	rtn_video.picture_default = vid_mate_dmplayer_config['metadata']['poster_url'];
	rtn_video.picture_big = vid_mate_dmplayer_config['metadata']['poster_url'];
	if (vid_mate_dmplayer_config['metadata']['qualities'] &&
		vid_mate_dmplayer_config['metadata']['qualities']["240"] &&
		vid_mate_dmplayer_config['metadata']['qualities']["240"][0]['url'])
	{
		var tmp_video_file = new vid_mate_video_file();
		tmp_video_file.url = vid_mate_dmplayer_config['metadata']['qualities']["240"][0]['url'];
		tmp_video_file.format = "mp4";
		tmp_video_file.title = "240p";
		tmp_video_file.f_id = rtn_video.id+"_240_mp4";
		rtn_video.files.push(tmp_video_file);
	}

	if (vid_mate_dmplayer_config['metadata']['qualities'] &&
		vid_mate_dmplayer_config['metadata']['qualities']["380"] &&
		vid_mate_dmplayer_config['metadata']['qualities']["380"][0]['url'])
	{
		var tmp_video_file = new vid_mate_video_file();
		tmp_video_file.url = vid_mate_dmplayer_config['metadata']['qualities']["380"][0]['url'];
		tmp_video_file.format = "mp4";
		tmp_video_file.title = "380p";
		tmp_video_file.f_id = rtn_video.id+"_380_mp4";
		rtn_video.files.push(tmp_video_file);
	}

	if (vid_mate_dmplayer_config['metadata']['qualities'] &&
		vid_mate_dmplayer_config['metadata']['qualities']["480"] &&
		vid_mate_dmplayer_config['metadata']['qualities']["480"][0]['url'])
	{
		var tmp_video_file = new vid_mate_video_file();
		tmp_video_file.url = vid_mate_dmplayer_config['metadata']['qualities']["480"][0]['url'];
		tmp_video_file.format = "mp4";
		tmp_video_file.title = "480p";
		tmp_video_file.f_id = rtn_video.id+"_480_mp4";
		rtn_video.files.push(tmp_video_file);
	}

	if (vid_mate_dmplayer_config['metadata']['qualities'] &&
		vid_mate_dmplayer_config['metadata']['qualities']["720"] &&
		vid_mate_dmplayer_config['metadata']['qualities']["720"][0]['url'])
	{
		var tmp_video_file = new vid_mate_video_file();
		tmp_video_file.url = vid_mate_dmplayer_config['metadata']['qualities']["720"][0]['url'];
		tmp_video_file.format = "mp4";
		tmp_video_file.title = "720p";
		tmp_video_file.f_id = rtn_video.id+"_720_mp4";
		rtn_video.files.push(tmp_video_file);
	}

	if (vid_mate_dmplayer_config['metadata']['qualities'] &&
		vid_mate_dmplayer_config['metadata']['qualities']["1080"] &&
		vid_mate_dmplayer_config['metadata']['qualities']["1080"][0]['url'])
	{
		var tmp_video_file = new vid_mate_video_file();
		tmp_video_file.url = vid_mate_dmplayer_config['metadata']['qualities']["1080"][0]['url'];
		tmp_video_file.format = "mp4";
		tmp_video_file.title = "1080p";
		tmp_video_file.f_id = rtn_video.id+"_1080_mp4";
		rtn_video.files.push(tmp_video_file);
	}
}

function yodesi_flash_analytics(rtn_video, vm_content)
{
	var video_title = "";
	var video_url = "";
	var video_img = "";
	video_title = cutstr(vm_content, "title:\"", "\"");
	if(!video_title)
	{
		if(!global_title)
		{
			video_title = "download yodesi mp4";
		}
		else
		{
			video_title = global_title; 
		}
	}
	
	video_img   = cutstr(vm_content, "\"poster\":\"", "\"");
	var hosting_id = cutstr(vm_content, "\"hostingId\":", ",");
	var publish_id = cutstr(vm_content, "\"publisherId\":", ",");
	var video_id = cutstr(vm_content, "\"videoId\":", ",");
	if(!hosting_id || !publish_id || !video_id)
	{
		vid_mate_error_default('yodesi a3');
		return null;
	}
	
	video_url = "https://cdn.video.playwire.com/" + publish_id + "/videos/" + video_id + "/video-mobile.mp4?hosting_id=" + hosting_id;
	rtn_video.title = video_title;
	rtn_video.url = document.URL;
	rtn_video.picture_default = video_img;
	rtn_video.picture_big = video_img;
	var tmp_video_file = new vid_mate_video_file();
	tmp_video_file.url = video_url;
	tmp_video_file.format = "mp4";
	tmp_video_file.title = "mp4(720p)";
	tmp_video_file.f_id = rtn_video.id;
	rtn_video.files.push(tmp_video_file);
}

function yodesi_other_analytics(rtn_video, vm_content)
{
	var video_title = "";
	var video_url = "";
	var video_img = "";
	video_title = cutstr(vm_content, "title:\"", "\"");
	if(!video_title)
	{
		if(!global_title)
		{
			video_title = "download yodesi mp4";
		}
		else
		{
			video_title = global_title; 
		}
	}
	
	video_img   = rcutstr(vm_content, "\"", ".jpg");
	if(video_img)
	{
		video_img = video_img + ".jpg";
	}
	
	video_url   = rcutstr(vm_content, "\"", "v.mp4");
	if(!video_url)
	{
		vid_mate_error_default('yodesi a5');
		return null;
	}
	
	video_url = video_url + "v.mp4"
	rtn_video.title = video_title;
	rtn_video.url = document.URL;
	rtn_video.picture_default = video_img;
	rtn_video.picture_big = video_img;
	var tmp_video_file = new vid_mate_video_file();
	tmp_video_file.url = video_url;
	tmp_video_file.format = "mp4";
	tmp_video_file.title = "mp4(720p)";
	tmp_video_file.f_id = rtn_video.id;
	rtn_video.files.push(tmp_video_file);
}

function rcutstr(content, prefix, suffix)
{
	var prefix_len = prefix.length;
	var p2 = content.indexOf(suffix);
	if(-1 == p2)
	{
		return "";
	}
	content = content.substr(0, p2);
	var p1 = content.lastIndexOf(prefix);
	if(-1 == p1)
	{
		return "";
	}
	return content.substring(p1 + prefix_len);
}
